import { StyleType, CollaborativeEditArgs, IAriaOptions } from './interface';
import { Spreadsheet } from '../base/index';
import { SheetModel } from '../../workbook/index';
/**
 * The function used to update Dom using requestAnimationFrame.
 * @param  {Function} fn - Function that contains the actual action
 * @return {Promise<T>}
 * @hidden
 */
export declare function getUpdateUsingRaf(fn: Function): void;
/**
 * The function used to remove the dom element children.
 * @param  parent -
 * @hidden
 */
export declare function removeAllChildren(parent: Element, index?: number): void;
/**
 * The function used to remove the dom element children.
 * @param  parent -
 * @hidden
 */
export declare function getColGroupWidth(index: number): number;
/** @hidden */
export declare function getScrollBarWidth(): number;
/** @hidden */
export declare function getSiblingsHeight(element: HTMLElement, classList?: string[]): number;
/**
 * @hidden
 */
export declare function inView(context: Spreadsheet, range: number[], isModify?: boolean): boolean;
/**
 * Position element with given range
 * @hidden
 */
export declare function locateElem(ele: Element, range: number[], sheet: SheetModel, isRtl?: boolean): void;
/**
 * To update element styles using request animation frame
 * @hidden
 */
export declare function setStyleAttribute(styles: StyleType[]): void;
/**
 * @hidden
 */
export declare function getStartEvent(): string;
/**
 * @hidden
 */
export declare function getMoveEvent(): string;
/**
 * @hidden
 */
export declare function getEndEvent(): string;
/**
 * @hidden
 */
export declare function isTouchStart(e: Event): boolean;
/**
 * @hidden
 */
export declare function isTouchMove(e: Event): boolean;
/**
 * @hidden
 */
export declare function isTouchEnd(e: Event): boolean;
/**
 * @hidden
 */
export declare function getClientX(e: TouchEvent & MouseEvent): number;
/**
 * @hidden
 */
export declare function getClientY(e: MouseEvent & TouchEvent): number;
/** @hidden */
export declare function setAriaOptions(target: HTMLElement, options: IAriaOptions<boolean>): void;
/**
 * @hidden
 */
export declare function destroyComponent(element: HTMLElement, component: Object): void;
/**
 * @hidden
 */
export declare function setResize(index: number, value: string, isCol: boolean, parent: Spreadsheet): void;
/**
 * @hidden
 */
export declare function setWidthAndHeight(trgt: HTMLElement, value: number, isCol: boolean): void;
/**
 * @hidden
 */
export declare function findMaxValue(table: HTMLElement, text: HTMLElement[], isCol: boolean, parent: Spreadsheet): number;
/**
 * @hidden
 */
export declare function updateAction(options: CollaborativeEditArgs, spreadsheet: Spreadsheet, isCutRedo?: boolean): void;
