import { SheetModel, ColumnModel } from './index';
import { ChildProperty } from '@syncfusion/ej2-base';
/**
 * Configures the Column behavior for the spreadsheet.
 */
export declare class Column extends ChildProperty<Column> {
    /**
     * Specifies index of the column. Based on the index, column properties are applied.
     * @default 0
     * @asptype int
     */
    index: number;
    /**
     * Specifies width of the column.
     * @default 64
     * @asptype int
     */
    width: number;
    /**
     * specifies custom width of the column.
     * @default false
     */
    customWidth: boolean;
    /**
     * To hide/show the column in spreadsheet.
     * @default false
     * @hidden
     */
    hidden: boolean;
}
/**
 * @hidden
 */
export declare function getColumn(sheet: SheetModel, colIndex: number): ColumnModel;
/**
 * @hidden
 */
export declare function getColumnWidth(sheet: SheetModel, index: number): number;
/**
 * @hidden
 */
export declare function getColumnsWidth(sheet: SheetModel, startCol: number, endCol?: number): number;
/** @hidden */
export declare function isHiddenCol(sheet: SheetModel, index: number): boolean;
