import { Workbook } from '../base/index';
/**
 * The `WorkbookSort` module is used to handle sort action in Spreadsheet.
 */
export declare class WorkbookSort {
    private parent;
    /**
     * Constructor for WorkbookSort module.
     */
    constructor(parent: Workbook);
    /**
     * To destroy the sort module.
     */
    protected destroy(): void;
    private addEventListener;
    private removeEventListener;
    /**
     * Sorts range of cells in the sheet.
     * @param args - arguments for sorting.
     */
    private initiateSortHandler;
    /**
     * Compares the two cells for sorting.
     * @param sortDescriptor - protocol for sorting.
     * @param caseSensitive - value for case sensitive.
     * @param x - first cell
     * @param y - second cell
     */
    private sortComparer;
    /**
     * Gets the module name.
     * @returns string
     */
    protected getModuleName(): string;
}
